<?php
namespace app\mz_chacm\controller;
use think\facade\Db;
use think\facade\Request;
use think\facade\View;
use vitphp\admin\auth\AnnotationAuth;
use vitphp\admin\controller\BaseController;
/**
 * @title 权限管理
 * Class auth
 * @package app\wx_vote\controller
 */
class Auth extends BaseController
{
    /**
     * @title 管理员列表
     */
    public function index(){
        $pid = input('pid');
        $user = Db::name('users')->where('pid',$pid)->select()->toArray();
        View::assign([
            'user'=>!empty($user)?$user:''
        ]);
        return View::fetch();
    }
    /**
     * @title 编辑用户
     */
    public function edit(){
        $pid = input('pid');
        $id = input('id');
        $user = Db::name('users')->where(['pid'=>$pid,'id'=>$id])->find();
        if(request()->isPost()){
            $username = input('username');
            $password = input('password');
            $repassword = input('repassword');
            (strlen($username)<6)&&$this->error('用户名长度必须大于6位');
            if(empty($id)){
                $has = Db::name('users')->where('username',$username)->count();
                $has&&$this->error("用户名已经存在或格式错误");
            }
            $param = [
                'username'=>input('username'),
                'pid'=>$pid,
                'create_time'=>time()
            ];
            if(!empty($password) || empty($id)){
                !preg_match('/^[a-zA-Z0-9]+$/',$username)&&$this->error('只能使用字母数字');
                (strlen($password) < 5 || strlen($password) > 25) && $this->error('密码长度必须5-25位之间');
                !preg_match('/^[a-zA-Z0-9]+$/', $password) && $this->error('只能使用字母数字');
                if(empty($id)){
                    ($password !== $repassword) && $this->error('两次密码输入不一致');
                    unset($repassword);
                }
                $password = pass_en($password);
                $param['password'] = $password;
            }
            if ($id){
                $res = Db::name('users')->where('id',$id)->update($param);
            }else{
                $id = Db::name("users")->insertGetId($param);
                $res = true;
            }
            $node = input('node',[]);
            $node_string = array_filter(explode(',',input('nodes','')));
            if(empty($node) || !is_array($node) || count($node_string) > count($node)){
                $node = $node_string;
            }
            if(is_array($node)){
                Db::table('vit_auth_nodes')->where('uid', $id)->delete();
                $dataSet = [];
                foreach ($node as $i=>$v){
                    $dataSet[] = ['rule_id'=>0,'uid'=>$id,'node'=>$v];
                }
                Db::table('vit_auth_nodes')->insertAll($dataSet);
            }

            if($res){
                $this->success("配置成功！",ToUrl('index'));
            }else{
                $this->error("配置失败！");
            }
        }
        $role_nodes = Db::table('vit_auth_nodes')
            ->whereIn('rule_id',  Db::table('vit_auth_map')
                ->where('admin_id', input('id'))
                ->column('role_id'))
            ->group('node')
            ->select()->column('node');
        $apps = AnnotationAuth::getAddonsAuth(app('http')->getName());
        $user_nodes = Db::table('vit_auth_nodes')
            ->where('uid', input('id'))
            ->select()->column('node');
        View::assign('auth_ids', []);
        View::assign('apps', $apps);
        View::assign('role_nodes', $role_nodes);
        View::assign('nodes', array_merge($role_nodes,$user_nodes));
        View::assign([
            'user'=>!empty($user)?$user:['id'=>null]
        ]);
        return View::fetch();
    }
    /**
     * @title 删除用户
     */
    public function deluser(){
        $id = $this->request->post('id');
        $query = Db::name('users')->where('id',$id)->delete();
        Db::table('vit_auth_nodes')->where('uid', $id)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
}