<?php
namespace app\mz_chacm\controller;
use app\ExcelExtend;
use think\facade\Db;
use think\facade\View;
use vitphp\admin\controller\BaseController;

/**
 * @title 卡密管理
 */
class Kami extends BaseController
{
    /**
     * @title 卡密列表
     */
    public function index(){
        $pid = input('pid');
        $kami = Db::name('mz_chacm_kami')->where(['pid'=>$pid])->order('id','desc')->paginate(20);
        View::assign([
            'kami'=>!empty($kami)?$kami:'',
            'page' => $kami->render()
        ]);
        return View::fetch();
	}
    /**
     * @title 生成卡密
     */
    public function edit(){
        $pid = input('pid');
        if($this->request->isPost()){
            $post = $this->request->post();
            if(!$post['day']) $this->error('请输入天数');
            if(!$post['num']) $this->error('请输入要生成的数量');
            if($post['num']>50) $this->error('一次最多生成50条');
            $data = [];
            for($i=0;$i<$post['num'];$i++){
                $data[] = [
                    'pid' => $pid,
                    'code' => redom(12),
                    'day' => $post['day'],
                    'create_time'=>time()
                ];
            }
            Db::name('mz_chacm_kami')->insertAll($data);
            $this->success('操作成功');
        }
        return View::fetch();
    }
    /**
     * @title 导出卡密
     */
    public function export()
    {
        $pid = input('pid');
        $type = input('type', 1);
        $db = Db::name('mz_chacm_kami')->where('pid', $pid);
        switch ($type){
            case 1:
                $data = $db->select();
                break;
            case 2:
                $data = $db->whereNotNull('end_time')->select();
                break;
            case 3:
                $data = $db->whereNull('end_time')->select();
                break;
        }
        if($data->isEmpty()) $this->error('暂无可导出数据');
        $data = $data->toArray();
        $exportData = [];
        foreach($data as $item){
            $status = $item['end_time'] ? '已使用' : '未使用';
            $exportData[] = [$item['code'], $status, $item['day']];
        }

        $title = ['卡密', '状态','有效天数'];
        $filename = '卡密列表';

        $excel = new ExcelExtend($filename);
        $excel->setTitle($title);
        $excel->setData($exportData);
        exit();
    }
    /**
     * @title 删除卡密
     */
    public function del(){
        $ids = $this->request->post('ids');
        $query = Db::name('mz_chacm_kami')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
}